apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ munin_name }}
    backups.opsperator.io/service: backups-{{ munin_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ munin_name }}
  name: {{ munin_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ munin_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ munin_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ munin_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ munin_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ munin_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ munin_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - command:
        - dumb-init
        - "--"
        - /start-apache.sh
        env:
        - name: APACHE_DOMAIN
          value: {{ munin_fqdn }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: AUTH_METHOD
{% if do_lemon %}
          value: oidc
{% elif do_ldap %}
          value: ldap
{% else %}
          value: none
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OIDC_CALLBACK_URL
{% if do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: munin
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: munin-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ munin_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
{% if do_ldap and not do_lemon %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=munin,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: munin-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% if not do_lemon %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ munin_ldap_user_objectclass }}
{% endif %}
{% endif %}
        - name: PING_PATH
          value: ""
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USER_FILTER
          value: ""
        - name: PING_PATH
          value: /ping
{% endif %}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='munin'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='munin'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ munin_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 40
          periodSeconds: 20
          timeoutSeconds: 15
        name: web
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ munin_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 13
        resources:
          limits:
            cpu: "{{ munin_web_cpu_limit }}"
            memory: "{{ munin_web_memory_limit }}"
          requests:
            cpu: "{{ munin_web_cpu_request }}"
            memory: "{{ munin_web_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: apachesites
          subPath: apache
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: apachesites
          subPath: ca-certificates
{% if do_ldap or do_lemon %}
        - mountPath: /usr/share/ca-certificates
          name: apachesites
          subPath: empty
{% endif %}
        - mountPath: /var/cache/munin/www
          name: data
          subPath: web
        - mountPath: /var/lib/munin
          name: data
          subPath: rrd
        - mountPath: /var/log/munin
          name: data
          subPath: logs
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
      - command:
        - dumb-init
        - "--"
        - /start-munin.sh
        env:
        - name: APACHE_DOMAIN
          value: {{ munin_fqdn }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: MAILFROM
          value: munin@{{ root_domain }}
        - name: MAILSERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: MAILPORT
          value: "{{ smtp_port | default('25') }}"
        - name: MAILTLS
          value: ""
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: MAILPORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: MAILTLS
          value: yay
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: MAILPORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: MAILTLS
          value: ""
{% else %}
          value: ""
        - name: MAILPORT
          value: ""
        - name: MAILTLS
          value: ""
{% endif %}
        - name: MONITOR_NODES
          value: "{% for entry in munin_collect_nodes %} {{ entry['name'] }}:{{ entry['address'] }}:{{ entry['port'] | default(4949) }}{% endfor %}"
        - name: MONITOR_SELF
          value: "true"
        - name: MUNIN_COLLECT_INTERVAL
          value: "{{ munin_collect_interval }}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='munin'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='munin'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                if ! test -s /var/lib/munin/datafile; then \
                    exit 1; \
                fi
          failureThreshold: 10
          initialDelaySeconds: 40
          periodSeconds: 20
          timeoutSeconds: 15
        name: munin
        resources:
          limits:
            cpu: "{{ munin_cpu_limit }}"
            memory: "{{ munin_memory_limit }}"
          requests:
            cpu: "{{ munin_cpu_request }}"
            memory: "{{ munin_memory_request }}"
        volumeMounts:
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /var/cache/munin/www
          name: data
          subPath: web
        - mountPath: /var/lib/munin
          name: data
          subPath: rrd
        - mountPath: /var/log/munin
          name: data
          subPath: logs
      - command:
        - dumb-init
        - "--"
        - /start-node.sh
        env:
        - name: APACHE_DOMAIN
          value: {{ munin_fqdn }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DEFAULT_PLUGINS
          value: {{ munin_default_plugins | join(' ') }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='munin'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='munin'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          tcpSocket:
            port: 4949
          initialDelaySeconds: 40
          periodSeconds: 20
          timeoutSeconds: 15
        name: node
        ports:
        - containerPort: 4949
        resources:
          limits:
            cpu: "{{ munin_node_cpu_limit }}"
            memory: "{{ munin_node_memory_limit }}"
          requests:
            cpu: "{{ munin_node_cpu_request }}"
            memory: "{{ munin_node_memory_request }}"
        volumeMounts:
        - mountPath: /var/cache/munin/www
          name: data
          subPath: web
        - mountPath: /var/lib/munin
          name: data
          subPath: rrd
        - mountPath: /var/log/munin
          name: data
          subPath: logs
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        volumeMounts:
        - mountPath: /home/backup
          name: apachesites
          subPath: bkphome
        - mountPath: /var/backup
          name: apachesites
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if do_exporters %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if rwo_storage is not defined and rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ munin_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: apachesites
      - name: data
        persistentVolumeClaim:
          claimName: {{ munin_name }}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ munin_name }}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='munin'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - web
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='munin'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='munin'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - munin
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='munin'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - node
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='munin'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
